(* This file was generated automatically by wayland-scanner-ocaml *)

open struct
  module Proxy = Wayland.Proxy
  module Iface_reg = Wayland.Iface_reg
  module Metadata = Wayland.Metadata
end

module Zxdg_decoration_manager_v1 = struct
  type t = [`Zxdg_decoration_manager_v1]
  type _ Metadata.ty += T : [`Zxdg_decoration_manager_v1] Metadata.ty
  type versions = [`V1]
  let interface = "zxdg_decoration_manager_v1"
  let version = 1l
  
  let requests = function
    | 0 -> "destroy", []
    | 1 -> "get_toplevel_decoration", ["id", `New_ID (Some "zxdg_toplevel_decoration_v1");
                                       "toplevel", `Object (Some "xdg_toplevel")]
    | i -> Proxy.unknown_request i, []
  
  let events = function
    | i -> Proxy.unknown_event i, []
  
end
let () = Iface_reg.register (module Zxdg_decoration_manager_v1)

module Zxdg_toplevel_decoration_v1 = struct
  type t = [`Zxdg_toplevel_decoration_v1]
  type _ Metadata.ty += T : [`Zxdg_toplevel_decoration_v1] Metadata.ty
  type versions = [`V1]
  let interface = "zxdg_toplevel_decoration_v1"
  let version = 1l
  
  module Error = struct
    type t =
      | Unconfigured_buffer : t
      | Already_constructed : t
      | Orphaned : t
    
    let to_int32 = function
      | Unconfigured_buffer -> 0l
      | Already_constructed -> 1l
      | Orphaned -> 2l
    
    let of_int32 = function
      | 0l -> Unconfigured_buffer
      | 1l -> Already_constructed
      | 2l -> Orphaned
      | x -> Fmt.failwith "Invalid error enum value %ld" x
  end
  
  
  (** Window decoration modes.
      
      These values describe window decoration modes. *)
  module Mode = struct
    type t =
      | Client_side : t
      | Server_side : t
    
    let to_int32 = function
      | Client_side -> 1l
      | Server_side -> 2l
    
    let of_int32 = function
      | 1l -> Client_side
      | 2l -> Server_side
      | x -> Fmt.failwith "Invalid mode enum value %ld" x
  end
  
  let requests = function
    | 0 -> "destroy", []
    | 1 -> "set_mode", ["mode", `Uint]
    | 2 -> "unset_mode", []
    | i -> Proxy.unknown_request i, []
  
  let events = function
    | 0 -> "configure", ["mode", `Uint]
    | i -> Proxy.unknown_event i, []
  
end
let () = Iface_reg.register (module Zxdg_toplevel_decoration_v1)
