(* This file was generated automatically by wayland-scanner-ocaml *)

[@@@ocaml.warning "-27"]
open struct
  module Imports = struct
    include Xdg_output_unstable_v1_proto
    include Wayland.Wayland_proto
  end
  
  module Proxy = Wayland.Proxy
  module Msg = Wayland.Msg
  module Fixed = Wayland.Fixed
  module Iface_reg = Wayland.Iface_reg
  module S = Wayland.S
end


(** Manage xdg_output objects.
    
    A global factory interface for xdg_output objects. *)
module Zxdg_output_manager_v1 = struct
  type 'v t = ([`Zxdg_output_manager_v1], 'v, [`Client]) Proxy.t
  
  (** {2 Version 1, 2, 3} *)
  
  (** Create an xdg output from a wl_output.
      
      This creates a new xdg_output object for the given wl_output. *)
  let get_xdg_output (_t:([< `V1 | `V2 | `V3] as 'v) t) (id:([`Zxdg_output_v1], 'v, [`Client]) #Proxy.Handler.t) ~(output:([`Wl_output], _, [`Client]) Proxy.t) =
    let __id = Proxy.spawn _t id in
    let _msg = Proxy.alloc _t ~op:1 ~ints:2 ~strings:[] ~arrays:[] in
    Msg.add_int _msg (Proxy.id __id);
    Msg.add_int _msg (Proxy.id output);
    Proxy.send _t _msg;
    __id
  
  (** Destroy the xdg_output_manager object.
      
      Using this request a client can tell the server that it is not
      going to use the xdg_output_manager object anymore.
      
      Any objects already created through this instance are not affected. *)
  let destroy (_t:([< `V1 | `V2 | `V3] as 'v) t)  =
    let _msg = Proxy.alloc _t ~op:0 ~ints:0 ~strings:[] ~arrays:[] in
    Proxy.send _t _msg;
    Proxy.shutdown_send _t
  
  (**/**)
  class ['v] _handlers_unsafe = object (_self : (_, 'v, _) #Proxy.Handler.t)
    method user_data = S.No_data
    method metadata = (module Xdg_output_unstable_v1_proto.Zxdg_output_manager_v1)
    method max_version = 3l
    
    
    method dispatch (_proxy : 'v t) _msg =
      let _proxy = Proxy.cast_version _proxy in
      match Msg.op _msg with
      | _ -> assert false
  end
  (**/**)
  
  (** {2 Handlers}
      Note: Servers will always want to use [v1].
   *)
  
  
  (** Handler for a proxy with version >= 1. *)
  class ['v] v1 = object (_ : (_, 'v, _) #Proxy.Service_handler.t)
    (**/**)
    inherit [[< `V1 | `V2 | `V3] as 'v] _handlers_unsafe
    (**/**)
    method min_version = 1l
    method bind_version : [`V1] = `V1
  end
  
  (** Handler for a proxy with version >= 2. *)
  class ['v] v2 = object (_ : (_, 'v, _) #Proxy.Service_handler.t)
    (**/**)
    inherit [[< `V2 | `V3] as 'v] _handlers_unsafe
    (**/**)
    method min_version = 2l
    method bind_version : [`V2] = `V2
  end
  
  (** Handler for a proxy with version >= 3. *)
  class ['v] v3 = object (_ : (_, 'v, _) #Proxy.Service_handler.t)
    (**/**)
    inherit [[< `V3] as 'v] _handlers_unsafe
    (**/**)
    method min_version = 3l
    method bind_version : [`V3] = `V3
  end
end

(** Compositor logical output region.
    
    An xdg_output describes part of the compositor geometry.
    
    This typically corresponds to a monitor that displays part of the
    compositor space.
    
    For objects version 3 onwards, after all xdg_output properties have been
    sent (when the object is created and when properties are updated), a
    wl_output.done event is sent. This allows changes to the output
    properties to be seen as atomic, even if they happen via multiple events. *)
module Zxdg_output_v1 = struct
  type 'v t = ([`Zxdg_output_v1], 'v, [`Client]) Proxy.t
  
  (** {2 Version 1} *)
  
  (** Destroy the xdg_output object.
      
      Using this request a client can tell the server that it is not
      going to use the xdg_output object anymore. *)
  let destroy (_t:([< `V1 | `V2 | `V3] as 'v) t)  =
    let _msg = Proxy.alloc _t ~op:0 ~ints:0 ~strings:[] ~arrays:[] in
    Proxy.send _t _msg;
    Proxy.shutdown_send _t
  
  
  (** {2 Version 2, 3} *)
  
  (**/**)
  class virtual ['v] _handlers_unsafe = object (_self : (_, 'v, _) #Proxy.Handler.t)
    method user_data = S.No_data
    method metadata = (module Xdg_output_unstable_v1_proto.Zxdg_output_v1)
    method max_version = 3l
    
    method private virtual on_logical_position : [> ] t -> x:int32 -> y:int32 -> unit
    
    method private virtual on_logical_size : [> ] t -> width:int32 -> height:int32 -> unit
    
    method private virtual on_done : [> ] t -> unit
    
    method private virtual on_name : [> ] t -> name:string -> unit
    
    method private virtual on_description : [> ] t -> description:string -> unit
    
    
    method dispatch (_proxy : 'v t) _msg =
      let _proxy = Proxy.cast_version _proxy in
      match Msg.op _msg with
      | 0 ->
        let x = Msg.get_int _msg in
        let y = Msg.get_int _msg in
        _self#on_logical_position _proxy ~x ~y
      | 1 ->
        let width = Msg.get_int _msg in
        let height = Msg.get_int _msg in
        _self#on_logical_size _proxy ~width ~height
      | 2 ->
        _self#on_done _proxy 
      | 3 ->
        let name = Msg.get_string _msg in
        _self#on_name _proxy ~name
      | 4 ->
        let description = Msg.get_string _msg in
        _self#on_description _proxy ~description
      | _ -> assert false
  end
  (**/**)
  
  (** {2 Handlers}
      Note: Servers will always want to use [v1].
   *)
  
  
  (** Handler for a proxy with version >= 1. *)
  class virtual ['v] v1 = object (_ : (_, 'v, _) #Proxy.Service_handler.t)
    (**/**)
    inherit [[< `V1 | `V2 | `V3] as 'v] _handlers_unsafe
    (**/**)
    method private virtual on_logical_position : [> `V1 | `V2 | `V3] t -> x:int32 -> y:int32 -> unit
    
    (** Position of the output within the global compositor space.
        
        The position event describes the location of the wl_output within
        the global compositor space.
        
        The logical_position event is sent after creating an xdg_output
        (see xdg_output_manager.get_xdg_output) and whenever the location
        of the output changes within the global compositor space. *)
    
    method private virtual on_logical_size : [> `V1 | `V2 | `V3] t -> width:int32 -> height:int32 -> unit
    
    (** Size of the output in the global compositor space.
        
        The logical_size event describes the size of the output in the
        global compositor space.
        
        For example, a surface without any buffer scale, transformation
        nor rotation set, with the size matching the logical_size will
        have the same size as the corresponding output when displayed.
        
        Most regular Wayland clients should not pay attention to the
        logical size and would rather rely on xdg_shell interfaces.
        
        Some clients such as Xwayland, however, need this to configure
        their surfaces in the global compositor space as the compositor
        may apply a different scale from what is advertised by the output
        scaling property (to achieve fractional scaling, for example).
        
        For example, for a wl_output mode 3840×2160 and a scale factor 2:
        
        - A compositor not scaling the surface buffers will advertise a
        logical size of 3840×2160,
        
        - A compositor automatically scaling the surface buffers will
        advertise a logical size of 1920×1080,
        
        - A compositor using a fractional scale of 1.5 will advertise a
        logical size to 2560×1620.
        
        For example, for a wl_output mode 1920×1080 and a 90 degree rotation,
        the compositor will advertise a logical size of 1080x1920.
        
        The logical_size event is sent after creating an xdg_output
        (see xdg_output_manager.get_xdg_output) and whenever the logical
        size of the output changes, either as a result of a change in the
        applied scale or because of a change in the corresponding output
        mode(see wl_output.mode) or transform (see wl_output.transform). *)
    
    method private virtual on_done : [> `V1 | `V2 | `V3] t -> unit
    
    (** All information about the output have been sent.
        
        This event is sent after all other properties of an xdg_output
        have been sent.
        
        This allows changes to the xdg_output properties to be seen as
        atomic, even if they happen via multiple events.
        
        For objects version 3 onwards, this event is deprecated. Compositors
        are not required to send it anymore and must send wl_output.done
        instead. *)
    
    method private virtual on_name : [> `V2 | `V3] t -> name:string -> unit
    
    (** Name of this output.
        
        Many compositors will assign names to their outputs, show them to the
        user, allow them to be configured by name, etc. The client may wish to
        know this name as well to offer the user similar behaviors.
        
        The naming convention is compositor defined, but limited to
        alphanumeric characters and dashes (-). Each name is unique among all
        wl_output globals, but if a wl_output global is destroyed the same name
        may be reused later. The names will also remain consistent across
        sessions with the same hardware and software configuration.
        
        Examples of names include 'HDMI-A-1', 'WL-1', 'X11-1', etc. However, do
        not assume that the name is a reflection of an underlying DRM
        connector, X11 connection, etc.
        
        The name event is sent after creating an xdg_output (see
        xdg_output_manager.get_xdg_output). This event is only sent once per
        xdg_output, and the name does not change over the lifetime of the
        wl_output global. *)
    
    method private virtual on_description : [> `V2 | `V3] t -> description:string -> unit
    
    (** Human-readable description of this output.
        
        Many compositors can produce human-readable descriptions of their
        outputs.  The client may wish to know this description as well, to
        communicate the user for various purposes.
        
        The description is a UTF-8 string with no convention defined for its
        contents. Examples might include 'Foocorp 11" Display' or 'Virtual X11
        output via :1'.
        
        The description event is sent after creating an xdg_output (see
        xdg_output_manager.get_xdg_output) and whenever the description
        changes. The description is optional, and may not be sent at all.
        
        For objects of version 2 and lower, this event is only sent once per
        xdg_output, and the description does not change over the lifetime of
        the wl_output global.
        " *)
    
    method min_version = 1l
  end
  
  (** Handler for a proxy with version >= 2. *)
  class virtual ['v] v2 = object (_ : (_, 'v, _) #Proxy.Service_handler.t)
    (**/**)
    inherit [[< `V2 | `V3] as 'v] _handlers_unsafe
    (**/**)
    method private virtual on_logical_position : [> `V2 | `V3] t -> x:int32 -> y:int32 -> unit
    
    (** Position of the output within the global compositor space.
        
        The position event describes the location of the wl_output within
        the global compositor space.
        
        The logical_position event is sent after creating an xdg_output
        (see xdg_output_manager.get_xdg_output) and whenever the location
        of the output changes within the global compositor space. *)
    
    method private virtual on_logical_size : [> `V2 | `V3] t -> width:int32 -> height:int32 -> unit
    
    (** Size of the output in the global compositor space.
        
        The logical_size event describes the size of the output in the
        global compositor space.
        
        For example, a surface without any buffer scale, transformation
        nor rotation set, with the size matching the logical_size will
        have the same size as the corresponding output when displayed.
        
        Most regular Wayland clients should not pay attention to the
        logical size and would rather rely on xdg_shell interfaces.
        
        Some clients such as Xwayland, however, need this to configure
        their surfaces in the global compositor space as the compositor
        may apply a different scale from what is advertised by the output
        scaling property (to achieve fractional scaling, for example).
        
        For example, for a wl_output mode 3840×2160 and a scale factor 2:
        
        - A compositor not scaling the surface buffers will advertise a
        logical size of 3840×2160,
        
        - A compositor automatically scaling the surface buffers will
        advertise a logical size of 1920×1080,
        
        - A compositor using a fractional scale of 1.5 will advertise a
        logical size to 2560×1620.
        
        For example, for a wl_output mode 1920×1080 and a 90 degree rotation,
        the compositor will advertise a logical size of 1080x1920.
        
        The logical_size event is sent after creating an xdg_output
        (see xdg_output_manager.get_xdg_output) and whenever the logical
        size of the output changes, either as a result of a change in the
        applied scale or because of a change in the corresponding output
        mode(see wl_output.mode) or transform (see wl_output.transform). *)
    
    method private virtual on_done : [> `V2 | `V3] t -> unit
    
    (** All information about the output have been sent.
        
        This event is sent after all other properties of an xdg_output
        have been sent.
        
        This allows changes to the xdg_output properties to be seen as
        atomic, even if they happen via multiple events.
        
        For objects version 3 onwards, this event is deprecated. Compositors
        are not required to send it anymore and must send wl_output.done
        instead. *)
    
    method private virtual on_name : [> `V2 | `V3] t -> name:string -> unit
    
    (** Name of this output.
        
        Many compositors will assign names to their outputs, show them to the
        user, allow them to be configured by name, etc. The client may wish to
        know this name as well to offer the user similar behaviors.
        
        The naming convention is compositor defined, but limited to
        alphanumeric characters and dashes (-). Each name is unique among all
        wl_output globals, but if a wl_output global is destroyed the same name
        may be reused later. The names will also remain consistent across
        sessions with the same hardware and software configuration.
        
        Examples of names include 'HDMI-A-1', 'WL-1', 'X11-1', etc. However, do
        not assume that the name is a reflection of an underlying DRM
        connector, X11 connection, etc.
        
        The name event is sent after creating an xdg_output (see
        xdg_output_manager.get_xdg_output). This event is only sent once per
        xdg_output, and the name does not change over the lifetime of the
        wl_output global. *)
    
    method private virtual on_description : [> `V2 | `V3] t -> description:string -> unit
    
    (** Human-readable description of this output.
        
        Many compositors can produce human-readable descriptions of their
        outputs.  The client may wish to know this description as well, to
        communicate the user for various purposes.
        
        The description is a UTF-8 string with no convention defined for its
        contents. Examples might include 'Foocorp 11" Display' or 'Virtual X11
        output via :1'.
        
        The description event is sent after creating an xdg_output (see
        xdg_output_manager.get_xdg_output) and whenever the description
        changes. The description is optional, and may not be sent at all.
        
        For objects of version 2 and lower, this event is only sent once per
        xdg_output, and the description does not change over the lifetime of
        the wl_output global.
        " *)
    
    method min_version = 2l
  end
  
  (** Handler for a proxy with version >= 3. *)
  class virtual ['v] v3 = object (_ : (_, 'v, _) #Proxy.Service_handler.t)
    (**/**)
    inherit [[< `V3] as 'v] _handlers_unsafe
    (**/**)
    method private virtual on_logical_position : [> `V3] t -> x:int32 -> y:int32 -> unit
    
    (** Position of the output within the global compositor space.
        
        The position event describes the location of the wl_output within
        the global compositor space.
        
        The logical_position event is sent after creating an xdg_output
        (see xdg_output_manager.get_xdg_output) and whenever the location
        of the output changes within the global compositor space. *)
    
    method private virtual on_logical_size : [> `V3] t -> width:int32 -> height:int32 -> unit
    
    (** Size of the output in the global compositor space.
        
        The logical_size event describes the size of the output in the
        global compositor space.
        
        For example, a surface without any buffer scale, transformation
        nor rotation set, with the size matching the logical_size will
        have the same size as the corresponding output when displayed.
        
        Most regular Wayland clients should not pay attention to the
        logical size and would rather rely on xdg_shell interfaces.
        
        Some clients such as Xwayland, however, need this to configure
        their surfaces in the global compositor space as the compositor
        may apply a different scale from what is advertised by the output
        scaling property (to achieve fractional scaling, for example).
        
        For example, for a wl_output mode 3840×2160 and a scale factor 2:
        
        - A compositor not scaling the surface buffers will advertise a
        logical size of 3840×2160,
        
        - A compositor automatically scaling the surface buffers will
        advertise a logical size of 1920×1080,
        
        - A compositor using a fractional scale of 1.5 will advertise a
        logical size to 2560×1620.
        
        For example, for a wl_output mode 1920×1080 and a 90 degree rotation,
        the compositor will advertise a logical size of 1080x1920.
        
        The logical_size event is sent after creating an xdg_output
        (see xdg_output_manager.get_xdg_output) and whenever the logical
        size of the output changes, either as a result of a change in the
        applied scale or because of a change in the corresponding output
        mode(see wl_output.mode) or transform (see wl_output.transform). *)
    
    method private virtual on_done : [> `V3] t -> unit
    
    (** All information about the output have been sent.
        
        This event is sent after all other properties of an xdg_output
        have been sent.
        
        This allows changes to the xdg_output properties to be seen as
        atomic, even if they happen via multiple events.
        
        For objects version 3 onwards, this event is deprecated. Compositors
        are not required to send it anymore and must send wl_output.done
        instead. *)
    
    method private virtual on_name : [> `V3] t -> name:string -> unit
    
    (** Name of this output.
        
        Many compositors will assign names to their outputs, show them to the
        user, allow them to be configured by name, etc. The client may wish to
        know this name as well to offer the user similar behaviors.
        
        The naming convention is compositor defined, but limited to
        alphanumeric characters and dashes (-). Each name is unique among all
        wl_output globals, but if a wl_output global is destroyed the same name
        may be reused later. The names will also remain consistent across
        sessions with the same hardware and software configuration.
        
        Examples of names include 'HDMI-A-1', 'WL-1', 'X11-1', etc. However, do
        not assume that the name is a reflection of an underlying DRM
        connector, X11 connection, etc.
        
        The name event is sent after creating an xdg_output (see
        xdg_output_manager.get_xdg_output). This event is only sent once per
        xdg_output, and the name does not change over the lifetime of the
        wl_output global. *)
    
    method private virtual on_description : [> `V3] t -> description:string -> unit
    
    (** Human-readable description of this output.
        
        Many compositors can produce human-readable descriptions of their
        outputs.  The client may wish to know this description as well, to
        communicate the user for various purposes.
        
        The description is a UTF-8 string with no convention defined for its
        contents. Examples might include 'Foocorp 11" Display' or 'Virtual X11
        output via :1'.
        
        The description event is sent after creating an xdg_output (see
        xdg_output_manager.get_xdg_output) and whenever the description
        changes. The description is optional, and may not be sent at all.
        
        For objects of version 2 and lower, this event is only sent once per
        xdg_output, and the description does not change over the lifetime of
        the wl_output global.
        " *)
    
    method min_version = 3l
  end
end